Packager: Igor Vlasenko <viy@altlinux.ru>
BuildRequires: /proc
BuildRequires: jpackage-compat
# Copyright (c) 2000-2007, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support 0


Name:           clirr
Summary:        Binary and Source Compatibility Check
Url:            http://clirr.sourceforge.net/
Version:        0.6
Release:        alt3_3jpp5
Epoch:          0
License:        LGPL
Group:          Development/Java
Source0:        http://prdownloads.sourceforge.net/clirr/clirr-0.6-src.zip

Source1:        pom-maven2jpp-depcat.xsl
Source2:        pom-maven2jpp-newdepmap.xsl
Source3:        pom-maven2jpp-mapdeps.xsl
Source4:        clirr-0.6-jpp-depmap.xml
Source5:        clirr-core-0.6.pom
Source6:        clirr-maven-0.6.pom

Patch0:         clirr-0.6-maven-plugin-project_xml.patch
# patch to bcel-5.2
Patch1:         clirr-0.6-BcelJavaType.patch

BuildRequires: jpackage-utils >= 0:1.6
BuildRequires: ant >= 0:1.6
BuildRequires: junit
BuildRequires: saxon
BuildRequires: saxon-scripts
BuildRequires: maven-plugins >= 0:1.1
BuildRequires: maven-plugins-base
BuildRequires: maven-plugin-changes
BuildRequires: maven-plugin-developer-activity
BuildRequires: maven-plugin-file-activity
BuildRequires: maven-plugin-jdepend
BuildRequires: maven-plugin-jxr
BuildRequires: maven-plugin-license
BuildRequires: maven-plugin-linkcheck
BuildRequires: maven-plugin-multiproject
BuildRequires: maven-plugin-tasklist
BuildRequires: maven-plugin-test
BuildRequires: maven-plugin-xdoc
BuildRequires: maven-model
BuildRequires: sf-javaapp-maven-plugin
BuildRequires: bcel >= 0:5.2
BuildRequires: jakarta-commons-cli
BuildRequires: jakarta-commons-jelly
BuildRequires: jakarta-commons-lang
#
#Requires: maven >= 0:1.1
#Requires: maven-model
Requires: bcel >= 0:5.2
Requires: jakarta-commons-cli
Requires: jakarta-commons-jelly
Requires: jakarta-commons-lang
%if %{gcj_support}
BuildRequires: gnu-crypto
BuildRequires: java-gcj-compat-devel
Requires(post): java-gcj-compat
Requires(postun): java-gcj-compat
%endif
%if ! %{gcj_support}
BuildArch:      noarch
%endif

%description
Clirr is a tool that checks Java libraries for binary and 
source compatibility with older releases. Basically you 
give it two sets of jar files and Clirr dumps out a list 
of changes in the public api. The Clirr Ant task can be 
configured to break the build if it detects incompatible 
api changes. In a continuous integration process Clirr 
can automatically prevent accidental introduction of 
binary or source compatibility problems.

%package maven-plugin
Summary:        Maven plugin for %{name}
Group:          Development/Java
Requires: %{name} = %{epoch}:%{version}
Requires: maven >= 0:1.1
Requires: sf-javaapp-maven-plugin

# moved form core package (strange deps for it)
Requires: maven >= 0:1.1                                                        
Requires: maven-model

%description maven-plugin
%{summary}.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description manual
%{summary}.

%prep
%setup -q -n %{name}-%{version}
chmod -R go=u-w *
for j in $(find . -name "*.jar"); do
    mv $j $j.no
done
%patch0 -b .sav
%patch1 -b .sav

if [ ! -f %{SOURCE4} ]; then
export DEPCAT=$(pwd)/clirr-0.6-depcat.new.xml
echo '<?xml version="1.0" standalone="yes"?>' > $DEPCAT
echo '<depset>' >> $DEPCAT
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    /usr/bin/saxon project.xml %{SOURCE1} >> $DEPCAT
    popd
done
echo >> $DEPCAT
echo '</depset>' >> $DEPCAT
/usr/bin/saxon $DEPCAT %{SOURCE2} > clirr-0.6-depmap.new.xml
fi

%build
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    cp project.xml project.xml.orig
    /usr/bin/saxon -o project.xml project.xml.orig %{SOURCE3} map=%{SOURCE4}
    popd
done

#export JAVA_HOME=/usr/lib/jvm/java-1.4.2

# dirty hack that finally works
mkdir -p .maven/repository/JPP/plugins/
ln -s /usr/share/java/maven-plugins/maven-javaapp-plugin.jar .maven/repository/JPP/plugins/
maven -Dmaven.compile.target=1.4 -Dmaven.repo.remote=file:/usr/share/maven/repository \
      -Dmaven.home.local=$(pwd)/.maven \
      -Dmaven.javadoc.source=1.4 \
      -Dgoal=jar:jar,jar:install,javadoc:generate,xdoc:transform \
      multiproject:goal

%install
# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}

install -m 644 core/target/%{name}-core-%{version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}-core-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# plugin
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven/plugins
install -m 644 \
    maven/target/%{name}-maven-%{version}.jar \
    $RPM_BUILD_ROOT%{_datadir}/maven/plugins/maven-clirr-plugin-%{version}.jar
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/maven-plugins
pushd $RPM_BUILD_ROOT%{_javadir}/maven-plugins
ln -sf \
    %{_datadir}/maven/plugins/maven-clirr-plugin-%{version}.jar \
    maven-clirr-plugin.jar
popd

%add_to_maven_depmap %{name} %{name}-core %{version} JPP %{name}

# poms
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -m 644 %{SOURCE5} \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-clirr-core.pom
install -m 644 %{SOURCE6} \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-clirr-maven.pom

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/core
cp -pr core/target/docs/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/core
rm -rf core/target/docs/apidocs
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/maven
cp -pr maven/target/docs/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/maven
rm -rf maven/target/docs/apidocs
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

# manual
install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/core
cp -pr core/target/docs/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/core
install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/maven
cp -pr maven/target/docs/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/maven

%if %{gcj_support}
export CLASSPATH=$(build-classpath gnu-crypto)
%{_bindir}/aot-compile-rpm
%endif

mkdir -p $RPM_BUILD_ROOT%_bindir/
cat > $RPM_BUILD_ROOT%_bindir/%name <<'EOF'
#!/bin/sh
# 
# Clirr startup script
#
# JPackage Project <http://www.jpackage.org/>

# Source functions library
if [ -f /usr/share/java-utils/java-functions ] ; then 
  . /usr/share/java-utils/java-functions
else
  echo "Can't find functions library, aborting"
  exit 1
fi

# Configuration
MAIN_CLASS=net.sf.clirr.cli.Clirr
BASE_JARS="bcel commons-cli commons-lang clirr-core"

# Set parameters
set_jvm
set_classpath $BASE_JARS
set_flags $BASE_FLAGS
set_options $BASE_OPTIONS

# Let's start
run "$@"
EOF

chmod 755 $RPM_BUILD_ROOT%_bindir/%name

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%if %{gcj_support}
%post
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%post maven-plugin
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun maven-plugin
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%doc LICENSE.txt
%{_javadir}/*
%{_datadir}/maven2/poms/JPP-clirr-core.pom
%{_mavendepmapfragdir}
%if %{gcj_support}
%dir %{_libdir}/gcj/%{name}
%{_libdir}/gcj/%{name}/%{name}-core-%{version}.jar.*
%endif
%exclude %_javadir/maven-plugins*
%_bindir/%name

%files maven-plugin
%doc LICENSE.txt
%{_datadir}/maven/plugins/maven-clirr-plugin*.jar
%{_javadir}/maven-plugins/maven-clirr-plugin.jar
%{_datadir}/maven2/poms/JPP-clirr-maven.pom
%if %{gcj_support}
%{_libdir}/gcj/%{name}/maven-%{name}-plugin-%{version}.jar.*
%endif

%files javadoc
%{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%files manual
%{_docdir}/%{name}-%{version}

%changelog
* Sat Oct 18 2008 Igor Vlasenko <viy@altlinux.ru> 0:0.6-alt3_3jpp5
- fixed build with java 5

* Wed Feb 13 2008 Igor Vlasenko <viy@altlinux.ru> 0:0.6-alt2_3jpp1.7
- misc fixes; added launch script

* Sun Nov 25 2007 Igor Vlasenko <viy@altlinux.ru> 0:0.6-alt2_2jpp1.7
-excluded maven plugin from clirr

* Wed Nov 21 2007 Igor Vlasenko <viy@altlinux.ru> 0:0.6-alt1_2jpp1.7
- converted from JPackage by jppimport script

